local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end
local AddonName, a = ...
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local c = BittensSpellFlashLibrary2

local function SnDIsNext()
    -- only called at 4 or 5 combo points, so no need to consider double combo
    -- point generation
    local SnD = a.spells["Slice and Dice"]
    local inactiveRegen, activeRegen = GetPowerRegen()
    local timeTillRefresh = s.BuffDuration(SnD.ID, "player") - SnD.EarlyRefresh
    if timeTillRefresh < 0 then
        timeTillRefresh = 0
    end
    return s.Power("player")
             + activeRegen * timeTillRefresh
             - (5 - GetComboPoints("player")) * 39
        < s.MaxPower("player") - (25 + activeRegen)
end

local function GetEnergy()
    local inactiveRegen, activeRegen = GetPowerRegen()
    return s.Power("player") + activeRegen * c.GetBusyTime()
end

------------------------------------------------------------------------ combat
a.spells["Blade Flurry"] = { ID = 13877 }

a.spells["Adrenaline Rush"] = {
    ID = 13750,
    NoGCD = 1,
    FlashColor = "yellow",
    CheckFirst = function()
        return s.Power("player") < 10
    end
}

a.spells["Killing Spree"] = {
    ID = 51690,
    FlashColor = "yellow",
    CheckFirst = function()
        return GetEnergy() < 15 and not c.HasBuff("Adrenaline Rush")
    end
}

a.spells["Slice and Dice"] = {
    ID = 5171,
    Buff = 5171,
    BuffUnit = "player",
    EarlyRefresh = 1,
    Unit = "player"
}

a.spells["Expose Armor"] = {
    ID = 8647,
    Debuff = c.ARMOR_DEBUFFS,
    EarlyRefresh = 5,
    Continue = 1,
    FlashColor = "yellow",
    CheckFirst = function()
        return GetComboPoints("player") == 5 and not SnDIsNext()
    end
}

a.spells["Rupture"] = {
    ID = 1943,
    MyDebuff = 1943,
    EarlyRefresh = 2,
    Continue = 1, 
    FlashColor = "yellow",
    CheckFirst = function()
        return GetComboPoints("player") == 5
            and not SnDIsNext()
            and not s.Buff("Blade Flurry", "player")
    end
}

a.spells["Eviscerate"] = {
    ID = 2098,
    CheckFirst = function()
        return GetComboPoints("player") == 5
            and not SnDIsNext()
    end
}

a.spells["Revealing Strike"] = {
    ID = 84617,
    MyDebuff = 84617,
    EarlyRefresh = 2,
    CheckFirst = function()
        return GetComboPoints("player") == 4 and not SnDIsNext()
    end
}

a.spells["Sinister Strike"] = {
    ID = 1752,
    CheckFirst = function()
        local cp = GetComboPoints("player") 
        return cp < 4 or (cp == 4 and SnDIsNext())
    end
}
